/* -*- mode: c -*- */
/*
 * Copyright 2005-2006  Francesco Nidito <nids@di.unipi.it>
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
 * AUTHOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
 * AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 * Except as contained in this notice, the name of the author shall not be used 
 * in advertising or otherwise to promote the sale, use or other dealings in this 
 * Software without prior written authorization from the author.
 */

#include "MainWindow.h"
#include <stdlib.h>
#include <string.h>

/* 
 * attach the prefix "[MESSAGE]:" before the string 
 * str than prints it to the output window.
 *
 * returns ERR is something went wrong and OK if 
 * everithing was fine
 */
int
PrintMessage(MainWindow_t* mw, 
	     const char* str
   )
{
   const char *msg = "[MESSAGE]: ";
   char *p;
   int r;

   if(!mw) return ERR;
   if(!str) return ERR;

   p = malloc(strlen(str)+strlen(msg)+1);
   sprintf(p,"%s%s",msg, str);
   r = PrintString(mw, p);
   free(p);

   return r;
}

