/* -*- mode: c -*- */
/*
 * Copyright 2005-2006  Francesco Nidito <nids@di.unipi.it>
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
 * AUTHOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
 * AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 * Except as contained in this notice, the name of the author shall not be used 
 * in advertising or otherwise to promote the sale, use or other dealings in this 
 * Software without prior written authorization from the author.
 */

#include "MainWindow.h"
#include <string.h>


/* 
 * reads at most length chars from input 
 * window.
 *
 * returns the number of chars red
 */
int
ReadString(MainWindow_t *mw, 
	   char* str,
	   int length)
{
   int r;

   if(!mw) return -1;
   if(!str) return -1;

   /*read the input up to length*/
   wgetnstr(mw->InWin, str, length);   
   r = strlen(str);
   
   pthread_mutex_lock(mw->Mutex);

   /*clean the input line*/
   wmove(mw->InWin, 0, 0);
   waddnstr(mw->InWin, mw->ClearString, mw->TermWidth-1);
   wrefresh(mw->InWin);  

   /*Put back focus on input bar*/
   mvwaddch(mw->InWin, 0, 0, '>');
   wrefresh(mw->InWin);  

   pthread_mutex_unlock(mw->Mutex);

   return r;
}
