/* -*- mode: c -*- */
/*
 * Copyright 2005-2006  Francesco Nidito <nids@di.unipi.it>
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
 * AUTHOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
 * AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 * Except as contained in this notice, the name of the author shall not be used 
 * in advertising or otherwise to promote the sale, use or other dealings in this 
 * Software without prior written authorization from the author.
 */

#include "MainWindow.h"
#include <stdlib.h>
#include <sys/ioctl.h>

/*
 * performs the resize of the window mw
 */
void
ResizeScreen(MainWindow_t *mw)
{
   int i;
   int w,h;
   struct winsize size;

   pthread_mutex_lock(mw->Mutex);

   /*finds out the term geometry*/
   ioctl(fileno(stdout), TIOCGWINSZ, &size);

   w = size.ws_col;
   h = size.ws_row;

   /*resize terminal*/
   resizeterm(h, w);
   wrefresh(curscr); 

   mw->TermHeight = h;
   mw->TermWidth = w;

   /*create new rubber*/
   free(mw->ClearString);
   mw->ClearString = malloc(sizeof(char)*w);

   for(i = 0; i<(w-1); ++i) mw->ClearString[i] = ' ';
   mw->ClearString[i] = '\0';

   /*resize out*/
   wresize(mw->OutWin, h-1, w);   
   box(mw->OutWin,0,0);
   redrawwin(mw->OutWin);
   wrefresh(mw->OutWin);

   /*move and resize in*/
   wresize(mw->InWin, 1, w);
   mvwin(mw->InWin,h-1,0);
   redrawwin(mw->InWin);
   wrefresh(mw->InWin);

   doupdate();

   pthread_mutex_unlock(mw->Mutex);
}

